import {
  select,
  csv,
  scaleLinear,
  extent,
  axisLeft,
  axisBottom,
} from 'd3';

import { dropdownMenu } from './dropdownmenu';
import { scatterPlot } from './scatterPlot';

const svg = select('svg');
const width = +svg.attr('width');
const height = +svg.attr('height');
const classColor = {'Iris-setosa':'#972ee8',
                    'Iris-versicolor': '#42c5f5',
                    'Iris-virginica': '#f54254'};
const allColumns = ['sepal length', 'sepal width', 'petal length', 'petal width']


//state
let data;
let xColumn;
let yColumn;


const onXcolumnClicked = column => {
  xColumn = column;
  render();
};

const onYcolumnClicked = column => {
  yColumn = column;
  render();
};

const render = () => {
	//console.log(data.columns)
  select('#x-menu')
    .call(dropdownMenu, {
      options: allColumns,
      onOptionClicked: onXcolumnClicked,
    	selectedOption: xColumn
    });
  
  select('#y-menu')
    .call(dropdownMenu, {
      options: allColumns,
      onOptionClicked: onYcolumnClicked,
    	selectedOption: yColumn
    });
  
  svg.call(scatterPlot, {
    title: 'Iris Scatter Plot',
    xValue: d => d[xColumn],
		xAxisLabel: xColumn,
  	yValue: d => d[yColumn],
 		circleRadius: 10,
		yAxisLabel: yColumn,
		margin: { top: 90, right: 240, bottom: 88, left: 120 },
    width,
    height,
    data,
    classColor
  });
  
  
}; 
/*
csv('http://vis.lab.djosix.com:2020/data/iris.csv')
  .then(loadedData => {
  	data = loadedData;
    data.forEach(d => {
      d.sepal_length = +d['sepal length'];
      d.sepal_width = +d['sepal width'];
      d.petal_length = +d['petal length'];
      d.petal_width = +d['petal width'];
      d.class = d['class'];
    });
  	xColumn = data.columns[0];
  	yColumn = data.columns[3];
    render();
  });
*/

//csv('http://vis.lab.djosix.com:2020/data/iris.csv')
//csv('https://raw.githubusercontent.com/harker2011/iris_test/main/iris.csv')
csv('iris.csv')
  .then(loadedData => {
  	data = loadedData;
    data.forEach(d => {
      d.sepal_length = +d['sepal length'];
      d.sepal_width = +d['sepal width'];
      d.petal_length = +d['petal length'];
      d.petal_width = +d['petal width'];
      d.class = d['class'];
    });
  	xColumn = data.columns[0];
  	yColumn = data.columns[3];
    render();
  });
